#include <vo_stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <vstypes.h>
#include <vs1005g.h>
#include <clockspeed.h>
#include <audio.h>
#include <timers.h>
#include <dsplib.h>
#include <crc32.h>


#define MIN(a,b) (((a)<(b))?(a):(b))


u_int16 buf[256];

ioresult main(char *param) {
  ioresult retCode = S_ERROR;
  FILE *fp = fopen(param, "rb");
  u_int32 bytes = 0;
  u_int32 crc32 = 0;

  if (!fp) {
    printf("E: File \"%s\" not found\n", param);
    goto finally;
  }

  fseek(fp, 0, SEEK_END);
  bytes = ftell(fp);
  fseek(fp, 0, SEEK_SET);
  printf("BYTES 0x%08lx\n", bytes);

  while (bytes > 1) {
    u_int16 toRead = MIN(bytes, 512) >> 1;
    fread(buf, 1, toRead, fp);
    crc32 = CalcCrc32(crc32, buf, 2*toRead);
    bytes -= 2*toRead;
  }
  if (bytes) {
    char c = fgetc(fp);
    crc32 = CalcCrc32Byte(crc32, c);
  }

  printf("CRC32 0x%08lx\n", crc32);
  retCode = S_OK;
 finally:
  if (fp) {
    fclose(fp);
    fp = NULL;
  }
  return retCode;
}
