#include <vo_stdio.h>
#include <volink.h>     // Linker directives like DLLENTRY
#include <apploader.h>  // RunLibraryFunction etc
#include <timers.h>
#include <consolestate.h>
#include <string.h>
#include <clockspeed.h>
#include <vs1005g.h>
#include <vo_gpio.h>
#include "intvectors.h"

#define GET_SOF_CNT() (PERIP(USB_UTMIR)&0x3FFF)
u_int16 GetLR1();
u_int16 GetLR0();

u_int16 itab[10];
u_int16 *ip = itab; 


void IntTimer1C(void) {
	*ip++ = GetLR1();
	if (ip > &itab[sizeof(itab)-1]) {
		ip = itab;
	}
}


void IntReguC(void) {
	u_int16 lr1 = GetLR1();
	u_int16 i;
	vo_stdout = vo_stderr;
	fprintf(vo_stderr,"\nSOF count: %d ",GET_SOF_CNT());
	fprintf(vo_stderr,"\nStop at %u(0x%04x): ",lr1,lr1);
	RunLibraryFunction("TRACE",ENTRY_1,lr1);
	fprintf(vo_stderr,"\nPrevious PC samples: ");
	for (i=0; i<sizeof(itab); i++) {
		fprintf(vo_stderr,"\n0x%04x=",itab[i]);
		RunLibraryFunction("TRACE",ENTRY_1,itab[i]);		
	}
	fprintf(vo_stderr,"\nSOF count: %d\n",GET_SOF_CNT());
	RunProgram("TASKS","-v");
	while(1);
}


ioresult main(char *parameters) {
	/* Set REGU (power button) interrupt vector. */
	WriteIMem((void *)(0x20+INTV_REGU), ReadIMem((void *)(&IntReguVector)));

	// Clock out any pending POWBTN keypress press
	PERIP(REGU_CF) |= REGU_CF_REGCK;
	PERIP(REGU_CF) &= ~REGU_CF_REGCK;
	PERIP(INT_ORIGIN1) |= INTF1_REGU;
	PERIP(REGU_CF) |= REGU_CF_REGCK;
	PERIP(REGU_CF) &= ~REGU_CF_REGCK;

	/* Activate REGU interrupt at lowest interrupt priority */
	PERIP(INT_ENABLE1_LP) |= INTF1_REGU;
	PERIP(INT_ENABLE1_HP) &= ~INTF1_REGU;

	WriteIMem((void *)(0x20 + INTV_TIMER1), ReadIMem((void *)(&IntTimer1Vector)));
	PERIP(TIMER_T1H) = (3000-1) >> 16;
	PERIP(TIMER_T1L) = (3000-1);
	PERIP(TIMER_ENA) |= TIMER_ENA_T1;
	PERIP(INT_ENABLE0_HP) |= INTF_TIMER1;


	return S_OK;
}
