
/*************************************************
 *
 * VS1005 FM-radio/RDS test code
 * 
 *************************************************/


#include <vo_stdio.h>
#include <vsos.h>
#include <vs1005g.h>
#include <stdlib.h>
#include <timers.h>
#include <exec.h>
#include "fm_init.h"
#include "fmModel.h"


u_int32 iq_levels[206*2];
__y u_int32 pi_levels[206*2];
// 
// delay_n(1M) makes about one second @ 36MHz
// 
void delay_n(long dlong) {
	int long xx;
#pragma msg 92 off
	for (xx=0; xx < dlong; xx++)
	USEY(0x4088);
#pragma msg 92 on
}

// This function generates about 1ms delay
// NOTE: CORE MUST BE IN 1X CLOCK (82ns cycle => 1ms is about 12195 cycles)
//       This delay was checked from gpio. Guess the loop hw must be used.
/*
void delay_ms(u_int16 del) {
	u_int16 i, j;
	for (i=0; i<del; i++) {      // i x 1 ms
		for (j=0; j<12195; j++) {  // about millisecond, assumin 1xclk i.e. 82ns
#pragma msg 92 off
			PERIP(0x4088);            // just read any dsp clock register
#pragma msg 92 on
		}
	}
}
*/

/// Configures FM hardware, sets DAC sample rate etc.
/// \todo Integrate this into the upcoming VSOS audio API.
void InitFM(void) {
	SetReguVoltage(0x7, 0x12, 0x15, 0x15);  // vsel, avdd, iovdd, cvdd
	    
	PERIP(CLK_CF) &= ~0x0020;     // go to 1x clock
	PERIP(CLK_CF) &= ~0x0020;     //
	PERIP(CLK_CF) &= ~0x0020;     //
	PERIP(CLK_CF) &= ~0x0020;     //
	PERIP(CLK_CF) &= ~0x0020;     //
	
	PERIP(CLK_CF)  = 0x0004;      //
	PERIP(CLK_CF)  = 0x0004;      //
	PERIP(CLK_CF)  = 0x0004;      //
	PERIP(CLK_CF)  = 0x0004;      //
	PERIP(CLK_CF)  = 0x0004;      //
	PERIP(CLK_CF)  = 0x0004;      //
	PERIP(CLK_CF)  = 0x0024;      // go to 5x clock
	
	PERIP(ANA_CF3) |= ANA_CF3_FMDIV24 | (0x7 << ANA_CF3_GAIN2_B) |(0x7 << ANA_CF3_GAIN1_B) | (0x7 <<ANA_CF3_2GCNTR_B);
	
	PERIP(ANA_CF2) |= (1<<15) | (1<<14) | ANA_CF2_TSTE | ANA_CF2_VCMST | ANA_CF2_LNA_ENA 
	| ANA_CF2_2G_ENA | ANA_CF2_AMP1_ENA | ANA_CF2_AMP2_ENA | ANA_CF2_USBLP | ANA_CF2_HIGH_REF | ANA_CF2_REF_ENA 
	| ANA_CF2_M3_ENA | ANA_CF2_M2_ENA |ANA_CF2_M1_ENA;  
	
	PERIP(ANA_CF0) &= ~ (ANA_CF0_M1LIN | ANA_CF0_M2LIN | ANA_CF0_M2MIC  | ANA_CF0_M1MIC); 
	PERIP(ANA_CF0) |= ANA_CF0_M2FM | ANA_CF0_M1FM | ANA_CF0_LCKST;
	PERIP(ANA_CF1) |= ANA_CF1_XTMODE | ANA_CF1_DBG | ANA_CF1_SAR_ENA | ANA_CF1_DA_ENA
		| ANA_CF1_DRV_ENA | 0x3 /*ANA_CF1_DAGAIN2*/;
	
	//PERIP(DAC_VOL)      = 0x0202;  // (+xdB)
	
	PERIP(FM_CF) |= FM_CF_FM_ENA | FM_CF_ENABLE;
	
	PERIP(AD_CF) &= ~((3 << AD_CF_ADFS_B) | (3 << AD_CF_DEC6SEL_B));
	PERIP(AD_CF) |= AD_CF_ADENA | AD_CF_DEC6ENA;
	
	// pll factor(12.288MHz) = 53127850.57   ~=  53127850 = 0x032A AAAA
	// pll factor(13.0MHz)   = 50218079.06   ~=  50218079 = 0x02FE 445F
	// pll factor(12.0MHz)   = 54402918.98   ~=  54402918 = 0x033E 1F66
	
	PERIP(FMPLL_LO) =  0xAAAA;
	PERIP(FMPLL_HI) =  0x032A;

	SetFMFreq(93700);
#if 0
	PERIP(INT_ENABLE1_LP) |= INTF1_RDS;
#endif
}


#if 0
u_int16 SetFM(u_int32 fmFreq) {
	const u_int32 clk = 12288; // in kHz, as is fmFreq
	u_int16 fmDiv = 0;
	u_int16 fmDivBit = 0;
	
	// obtain FMCCF_reg
	// Datasheet: 11.9.2
	// FMCCF_reg = ((F_fm / F_xtal * FM_div - 4*VCO_div) -16) * 2^21
	
	// find dividers
	if (fmFreq > 106000) {
		fmDiv = 16;
		fmDivBit = 0;
	} else {
		fmDiv = 20;
		fmDivBit = 1;
	}
	
	
	
}
#endif


#if 0
// Added: Thu Jun 21 10:04:39 EEST 2012
// 
// Samples given sar channel avgcnt times and returns avegered data
// (avgcnt times samples / avgcnt). avgcnt must be between 1 - 63
// 05F/05G: 12: aux0,        7: aux1,  0: aux2, 2: aux3,  4: aux4,
//           6: RTCvdd,      5: cvdd,  3: vco,  1: DLL,  10: VHIGH_div,
//d         11: ??(floating))
u_int16 SARChanAvg(u_int16 chan, u_int16 avgcnt) {
	u_int16 cnt, i;
	u_int16 sarsamples = 0;
	cnt = avgcnt;
	if (avgcnt > 63) {
		cnt = 63;
	}
	if (avgcnt < 1 ) {
		cnt = 1;
	}
	// configure SAR
	PERIP(ANA_CF1)  |= (1<<8);      // pdown, ANA_CF1_SARENA;
	PERIP(SAR_CF)     =  0;
	//PERIP(SAR_CF)     = ((chan)<<8) | (3<<6) | 0x07; // fastest, continuous, go
	//DEF//
	PERIP(SAR_CF) = ((chan)<<8)|(3<<6)|0x07; // +7 cycles, continuous, go
	//PERIP(SAR_CF) = ((chan)<<8) | (3<<6) | 0x3F; // +x cycles, continuous, go
	// scrap first data
	while (!(PERIP(INT_ORIGIN1) & INTF1_SAR))          //  int
	;
	PERIP(INT_ORIGIN1) = INTF1_SAR;
	// scrap 2nd data
	while (!(PERIP(INT_ORIGIN1) & INTF1_SAR))          //  int
	;
	PERIP(INT_ORIGIN1) = INTF1_SAR;
	for (i=1; i<=cnt; i++ ) {
		while (!(PERIP(INT_ORIGIN1) & INTF1_SAR))        //  int
		;
		PERIP(INT_ORIGIN1) = INTF1_SAR;
		sarsamples += PERIP(SAR_DAT);
		// printf("  %d", PERIP(SAR_DAT));
	}
	// printf("  <<< %d\n", sarsamples);
	PERIP(SAR_CF)    = 0;          // disable
	PERIP(ANA_CF1) &= ~(1<<8);    // disable
	sarsamples = sarsamples / cnt;
	// printf("\n  SAR chan %d: %d\n", chan, sarsamples);
	PERIP(INT_ORIGIN1) = INTF1_SAR;
	return sarsamples;
}
#endif


u_int32 fmBoundary[2] = {0,0}; /*86000L,104500L*/


u_int16 SetFMFreq(u_int32 fmband) {
  u_int16 anacf3  = 0;
  u_int16 vcolck  = 0;
  u_int16 locks   = 0;
  u_int16 cntrlck[3];
  s_int16 cntr    = 0;
  s_int32 sdm     = 0;
  u_int32 fract   = 0;
  u_int32 vcomult = 0;
  u_int32 vcofreq = 0;
  u_int16 vco_div = 0;
  u_int16 fm_div  = 0;
  u_int16 fm_div_bits = 0;
  u_int16 clk = 12288;
  s_int32 fvco;
  u_int16 vcodiv;
  s_int32 sdmtmp  = 0;

#if 0
  printf("SetFMFreq(%ld) ", fmband);
#endif

  if (!fmBoundary[0]) {
    s_int16 i;
    fmBoundary[1] = 120000;

    for (i=0; i<2; i++) {
      u_int32 lo, hi;
      u_int32 startT, t;

      startT = i ? 105000 : 85000;
      fmBoundary[i] = startT - 40000;
      
      lo = hi = t = startT;
      while (SetFMFreq(t-=500)) {
	lo = t;
#if 0
	printf("##1 %ld\n", t);
#endif
      }
      t = startT;
#if 0
      fmBoundary[i] = startT + 40000;
      while (SetFMFreq(t+=500)) {
	hi = t;
#if 0
	printf("##2 %ld\n", t);
#endif
      }
      fmBoundary[i] = (lo+hi)/2;
#else
      fmBoundary[i] = lo+500;
#endif
      
#if 0
      printf("####3 %ld\n", fmBoundary[i]);
#endif
    }
  }

#if 0
  if (fmband < FM_LOW-2*FM_STEP || fmband > FM_HIGH+2*FM_STEP) {
    printf("ERROR: bad input frequency (%lu)\n", fmband);
    return 0;
  }
#endif

  PERIP(FM_CF) &= ~(FM_CF_PHCOMP); // disable phcomp
	
  // NOTE: assuming FM mode, all power etc. ON
  cntrlck[0] = 0;
  cntrlck[1] = 0;
  cntrlck[2] = 0;
  sdm = 0;

  if (fmband < fmBoundary[0]) {        // about 86000L
    fm_div = 24;
    fm_div_bits = 3;    // 1 and 3 should be same thing "(x)1"
  } else if (fmband > fmBoundary[1]) {   // about 103000L
    fm_div = 16;
    fm_div_bits = 0;
  } else {
    fm_div = 20;
    fm_div_bits = 2;
  }


  vcomult = (fmband * (long)fm_div) / clk;
	
  clk = (clk>>3);   // assuming xtal is x*1kHz so no rounding errors
  vcofreq =  fmband * (long)fm_div * (0x00008000L>>6); // scale to fit 32 bits
  if (vcomult > 144L) {
    fract    = (0xFFB80000L>>3);       // -144*0x00008000
    vco_div  = 0;
    vcodiv   = 36;
  } else {  // else if (vcomult > 120L) {
    fract    =  (0xFFC40000L>>3);      // -120*0x00008000
    vco_div  = 2;
    vcodiv   = 30;
  }

#if 0
  printf("  fm_div %d, vcodiv %d, vcomult %ld, ", fm_div, vcodiv, vcomult);
#endif
  
  fract = clk*fract + vcofreq;
	
  fract = fract*2;
  //  calculating: fract = 256 * fract/clk    // 4*8*8
  {
    u_int32 tmpfract, error, tmpfract2;
    tmpfract = fract/clk;    // 99669.33333
    error    = fract - (clk * tmpfract);
    error    = (error<<16);
    tmpfract2 = error / clk;
    tmpfract2 = (tmpfract2>>(16-8));
    fract = (tmpfract<<8) + tmpfract2;
  }
	
  sdm = (fract ^ 0x02000000) & 0x03FFFFFF;
  {
    u_int16 ccf = (u_int16)(fract>>21);
#if 0
    printf("sdm %08lx, ccf %d, ", sdm, ccf);
#endif
    /* Limit the CCD according to datasheet rules */
    if (ccf >= vcodiv-2 || ccf >= 31) {
#if 0
      printf("BAD CCF %d, vcodiv %d!\n", ccf, vcodiv);
#endif
      vcolck = 0;
      goto finally;
    }
  }
  
  // find working cntr area
  PERIP(FMCCF_HI) = 0;
  PERIP(FMCCF_LO) = 0;
  PERIP(FMCCF_HI)  = (u_int16)(sdm>>16);
  PERIP(FMCCF_LO)  = (u_int16) sdm;
	
	
  locks = 0; // no locks yet
  //
  // 0xF is the slowest, 0x0 is the fastest cntr freq area
  //
  anacf3 = PERIP(ANA_CF3) & ~((3*ANA_CF3_FMDIV) | (3*ANA_CF3_DIV) |
			      ANA_CF3_2GCNTR_MASK);
  anacf3 |= fm_div_bits*ANA_CF3_FMDIV | vco_div*ANA_CF3_DIV;
  PERIP(ANA_CF3) = anacf3;
  // Would be nice to have some kind of starting guess...
  for (cntr=15; cntr>=0; cntr--) {
    // FMdiv[13:12], div[11:10], cntr[3:0]
    anacf3 &= ~ANA_CF3_2GCNTR_MASK;
    anacf3 |= cntr*ANA_CF3_2GCNTR;
    PERIP(ANA_CF3) = anacf3;
    //Delay(1);//delay_n(100000);
    vcolck  = CheckRFLck(0);           // param: printena
#if 0
    printf("%d", vcolck);
#endif
    if (vcolck == 1) {
      cntrlck[locks] = cntr;
      if (++locks == 3) {
	break;
      }
      // printf() SARChanAvg(3, 8) // chan=3, cnt=8
    } else if (locks) { // 3:43
      // max possible is 3 locks, if two locks found and
      // then no lock => also break (there can not be any more locks)
      break;
    }
  }
#if 0
  printf("\n");
#endif
  if (locks == 0) {
    Delay(1);//delay_ms(100);  // add delay, SEEMS TO BE VERY IMPORTATN DELAY...
  }
  
  // decide which cntr area to use
  anacf3 &= ~ANA_CF3_2GCNTR_MASK;
  if (locks == 3) {
    anacf3 |= cntrlck[1];       // middle
  } else if (locks == 1) {
    anacf3 |= cntrlck[0];       // first and only one
  } else { // 2 locks
    // => try to find best one by checking locks around the band
    s_int16 j, k;
    u_int16 lckstat[2] = {0,0};

    
    // FIGURE BEST CNTR AREA
    // slower area => check upper side locks
    // check + n*100kHz for slower cntr area
    // printf("    SEARCH %x  ++\n", cntrlck[0]);
    for (j=0; j<2; j++) {
      vcolck = 1;
      for (k=1; k<=5 && vcolck; k++) {           // loop freq offset *100kHz
	anacf3 &= ~ANA_CF3_2GCNTR_MASK;
	anacf3 |= cntrlck[j];          // 1st
	PERIP(ANA_CF3)  = anacf3;
	sdmtmp = sdm + (j?-k:k) * 0x00055550L;
	//	printf("j%d k%d sdm %08lx, sdmtmp %08lx\n", j, k, sdm, sdmtmp);
	PERIP(FMCCF_HI) = 0;
	PERIP(FMCCF_LO) = 0;
	PERIP(FMCCF_HI) = (u_int16)(sdmtmp>>16);
	PERIP(FMCCF_LO) = (u_int16)sdmtmp;
	vcolck = CheckRFLck(0);           // param: printena
	lckstat[j] += vcolck;           // param: printena
      }
    }
#if 0
    printf("   lckstat: %x %x, ", lckstat[0], lckstat[1]);
#endif
    PERIP(FMCCF_HI) = 0;
    PERIP(FMCCF_LO) = 0;
    PERIP(FMCCF_HI) = (u_int16)(sdm>>16);
    PERIP(FMCCF_LO) = (u_int16)sdm;
    anacf3 &= ~ANA_CF3_2GCNTR_MASK;
    anacf3 |= cntrlck[lckstat[1]>lckstat[0]];
  } /* If 2 locks */
#if 0
  printf("  ANA_CF3 = %04x\n", anacf3);
#endif
  
  PERIP(ANA_CF3) = anacf3;
  if (locks == 0) {
    PERIP(ANA_CF3) |= ANA_CF3_2GCNTR_MASK;
  }
  
  //Delay(1); //delay_n(1000);
  vcolck  = CheckRFLck(0);                   // param: printena
  // {
  //   modu = ( sdm / 2097152L) + 16;
  //   fvco = (4*vcodiv + modu) * 12e-3;        // scale to GHz
  // }
 finally:
  return vcolck;
}



u_int16 CheckRFLck(u_int16 printena) {
	u_int16 lockstat;
	PERIP(ANA_CF0) |= ANA_CF0_LCKCHK; // 0x0008;    // lock set high
	Delay(1); // actually only 20us needed
	
	PERIP(ANA_CF0) &= ~ANA_CF0_LCKCHK;
	
	Delay(1);// wait some time to see quality of vco lock
				// actually only 1us needed
	lockstat = (PERIP(ANA_CF0) >> ANA_CF0_LCKST_B) & 0x0001;
	if (printena == 1) {
		printf("   RF vco lck: %d\n", lockstat);
		fflush (stdout);
	}
	return lockstat;              // '1' when locked
}


void SetReguVoltage(u_int16 vsel, u_int16 avdd, u_int16 iovdd, u_int16 cvdd) {
	// REGU_VOLT     0xFED0
	//         14-10  ->  regu_avdd_ctrl_rs
	//         9-5    ->  regu_iovdd_ctrl_rs
	//         4-0    ->  regu_cvdd_ctrl_rs   (0x0F => 1.681V chip1, 1.7V chip2)
	// REGU_CF   0x(FEC)E
	//          5     -> ad_enax_rs      (default '0', i.e. clock enabled)
	//          4     -> fm_enax_rs      (default '0', i.e. clock enabled)
	//          3     -> regu_reg_clk_rs
	//          2-0   -> regu_shutdown_rs
	{
		u_int16 cvdd2, iovdd2, avdd2;
		if (vsel % 2 == 1) {    // change core voltage
			cvdd2 = 0x001F & cvdd;
		}
		else {
			cvdd2 = PERIP(REGU_VOLT) & 0x0001F;
		}
		
		if ((vsel>>1) % 2 == 1) {    // change io voltage
			iovdd2 =  ((iovdd & 0x001F)<<5);    //  & 0x03E0;
		}
		else {
			iovdd2 = PERIP(REGU_VOLT) & 0x03E0;
		}
    
		if ((vsel>>2) % 2 == 1) {    // change analog voltage
			avdd2 =  ((avdd & 0x001F)<<10);    //  & 0x7C00;
		}
		else {
			avdd2 = PERIP(REGU_VOLT) & 0x7C00;
		}
    	
		PERIP(REGU_VOLT) = avdd2 | iovdd2 | cvdd2;
		PERIP(REGU_CF) &= ~0x0008;
		PERIP(REGU_CF) |=  0x0008;  // toggle clock
		PERIP(REGU_CF) &= ~0x0008;
	}
}










